*********************************************************************
* GenRepoX 1.1 - ReportExtender
*********************************************************************
* (c) by Markus Egger (EPS-Software)
* Almerstrae 12, A-5760 Saalfelden
* Tel.: 0043-6582-5183  FAX: 0043-6582-6438
* CIS: 100337,1062
*********************************************************************
* Possible GenRepoX-Driver: _GRXDRV1 - _GRXDRV7
* This drivers can be defined in the global comment snippet
* of a report, or in the CONFIG.FPw
* You can use as much drivers as you want for every hook...
*********************************************************************

PARA _grx_command, _grx_run, _grx_startup

* Tis is the old parameter-line
*PARA _grx_rep_name, _grx_rep_expr, _grx_run, _grx_fld_sort

_grx_command=UPPER(_grx_command)
_grx_rep_name=SUBST(_grx_command,AT(" ",_grx_command,2))
_grx_rep_name=ALLT(_grx_rep_name)
_grx_rep_expr=ALLT(SUBS(_grx_rep_name,AT(" ",_grx_rep_name)))
_grx_rep_name=ALLT(LEFT(_grx_rep_name,AT(" ",_grx_rep_name)))
_grx_fld_sort=""

IF PARA()<2
	_grx_run=.T.
ENDIF
IF PARA()<3
	_grx_fld_sort=""
ENDIF

IF !INT(fox_ver())=2
	?? CHR(7)
	WAIT WIND "GenRepoX is built for FoxPro 2.x only! - [ENTER]"
	RETURN
ENDIF

IF NOT is_exe()
	WAIT WIND "running GenRepoX -  by Markus Egger" NOWA
ENDIF

* some of the used variables...
cr=CHR(13)
lf=CHR(10)
cr_lf=cr+lf
_grx_must_comp=!is_exe()


*available functions...
_grxf_crwcl		= "*:DEFI_WHEN_CLASS"
_grxf_usewcl	= "*:USE_WHEN_CLASS"
_grxf_crecl		= "*:DEFI_EXPR_CLASS"
_grxf_useecl	= "*:USE_EXPR_CLASS"
_grxf_crfcl		= "*:DEFI_PICT_CLASS"
_grxf_usefcl	= "*:USE_PICT_CLASS"
_grxf_delete	= "*:DELETE"
_grxf_delobj	= "*:DELOBJ"
_grxf_colors	= "*:RGB_COLOR"
_grxf_underline	= "*:UNDERLINE"
_grxf_begfnctn	= "*:FUNCTION"
_grxf_endfnctn	= "*:ENDFNCT"
_grxf_detail	= "*:DETAIL"
_grxf_if_color	= "*:IF_COLOR"
_grxf_sort_obj	= "*:SORTOBJ"
_grxf_pos_over	= "*:POSOVER"
_grxs_sortorder	= "*:SORTORDER"
_grxs_so_col	= "*:SORTCOL"
_grxs_so_space	= "*:SORTSPACE"
_grxs_dosort	= "*:DOSORT"

_grx_sele=SELE()
SELE 0
* Define Repo-Name
_grx_rep_name=UPPER(ALLT(_grx_rep_name))
_grx_rep_name=STRT(_grx_rep_name,".FRX","")

* Erase dummy-Repo-file
IF FILE("GENREPOX.FRX")
	ERASE genrepox.frx
ENDIF
IF FILE("GENREPOX.FRT")
	ERASE genrepox.frt
ENDIF

* create used variables...
* Class Array: column1=name, column2=when, colum3=remove line (.t. or .f.)
_grx_wc_cols=3
DIME _grxcl_when(4,_grx_wc_cols)
_grxcl_when(1,1)="GRX_PageOne"
_grxcl_when(1,2)="_pageno=1"
_grxcl_when(1,3)=.T.
_grxcl_when(2,1)="GRX_not_PageOne"
_grxcl_when(2,2)="not _pageno=1"
_grxcl_when(2,3)=.T.
_grx_ec_cols=2
DIME _grxcl_expr(1,_grx_ec_cols)
_grx_fc_cols=2
DIME _grxcl_fmt(1,_grx_fc_cols)

* Create dummy-Report
_grx_source=_grx_rep_name+".FRX"
COPY FILE (_grx_source) TO genrepox.frx
_grx_source=_grx_rep_name+".FRT"
COPY FILE (_grx_source) TO genrepox.frt

USE genrepox.frx ALIA grx EXCL
* Insert parameter-startup
GO TOP
IF NOT EMPTY(_grx_startup)
	REPL comment WITH _grx_startup
ENDIF

* Define a Cursor which contains all the Setup-Definitions... (upper case)
SELE 0
CREA CURS grx_defi (config m)
APPEND BLANK
IF NOT EMPTY(SYS(2019))
	APPEND MEMO config FROM (SYS(2019))
ENDIF
REPL config WITH config+cr_lf+grx.comment
REPL config WITH UPPER(config)
SELE grx

* Delete old Functions...
CALC MAX(timestamp) TO _grx_stamp
_grx_stamp=_grx_stamp+1
GO TOP
IF _grx_must_comp
	REPL grx.picture WITH ""
ENDIF

* Look for parameters in the global comment-snippet...
GO TOP

* Look for Sortorder...
IF NOT _grx_at(_grxs_sortorder,grx.comment)=0
	_grx_fld_sort=SUBS(grx.comment,_grx_at(_grxs_sortorder,grx.comment))
	_grx_fld_sort=ALLT(STRT(_grx_fld_sort,_grxs_sortorder,""))
	IF NOT AT(CHR(13),_grx_fld_sort)=0
		_grx_fld_sort=LEFT(_grx_fld_sort,AT(CHR(13),_grx_fld_sort)-1)
	ENDIF
ENDIF
_grx_fld_sort=UPPER(_grx_fld_sort)

* Look for sortorder positions...
IF NOT _grx_at(_grxs_so_col,grx.comment)=0
	_grx_sf_pos=SUBS(grx.comment,_grx_at(_grxs_so_col,grx.comment))
	_grx_sf_pos=ALLT(STRT(_grx_sf_pos,_grxs_so_col,""))
	IF NOT AT(CHR(13),_grx_sf_pos)=0
		_grx_sf_pos=LEFT(_grx_sf_pos,AT(CHR(13),_grx_sf_pos)-1)
	ENDIF
	_grx_sf_pos=VAL(ALLT(_grx_sf_pos))
ELSE
	* Use 1.500 as std-position for sorted fields (standard)
	_grx_sf_pos=1500
ENDIF

* Look for sortorder space...
IF NOT _grx_at(_grxs_so_space,grx.comment)=0
	_grx_sf_add=SUBS(grx.comment,_grx_at(_grxs_so_space,grx.comment))
	_grx_sf_add=ALLT(STRT(_grx_sf_add,_grxs_so_space,""))
	IF NOT AT(CHR(13),_grx_sf_add)=0
		_grx_sf_add=LEFT(_grx_sf_add,AT(CHR(13),_grx_sf_add)-1)
	ENDIF
	_grx_sf_add=VAL(ALLT(_grx_sf_add))
ELSE
	* Use 200 as std-space for sorted fields (standard)
	_grx_sf_add=200
ENDIF

*Look for SortObjects-Command...
IF NOT _grx_at(_grxs_dosort,grx.comment)=0
	_grx_so_prg=SUBS(grx.comment,_grx_at(_grxs_dosort,grx.comment))
	_grx_so_prg=ALLT(STRT(_grx_so_prg,_grxs_dosort,""))
	IF NOT AT(CHR(13),_grx_so_prg)=0
		_grx_so_prg=LEFT(_grx_so_prg,AT(CHR(13),_grx_so_prg)-1)
	ENDIF
	_grx_so_prg=VAL(ALLT(_grx_so_prg))
	IF EMPTY(_grx_so_prg)
		_grx_so_prg="DOSORT.SPR"
	ENDIF
	DO &_grx_so_prg
ENDIF


* Sort fields...
_grx_2fld_sort=_grx_fld_sort
_grx_fld_sort=ALLT(STRT(_grx_fld_sort," ",""))
DO WHILE NOT EMPTY(_grx_fld_sort)
	IF NOT AT(",",_grx_fld_sort)=0
		_grx_search=_grxf_sort_obj+" "+UPPER(LEFT(_grx_fld_sort,AT(",",_grx_fld_sort)-1))
		_grx_fld_sort=RIGHT(_grx_fld_sort,LEN(_grx_fld_sort)-AT(",",_grx_fld_sort))
	ELSE
		_grx_search=ALLT(_grxf_sort_obj)+" "+ALLT(_grx_fld_sort)
		_grx_fld_sort=""
	ENDIF
	IF NOT AT(CHR(13),_grx_search)=0
		_grx_search=LEFT(_grx_search,AT(CHR(13),_grx_search)-1)
	ENDIF
	GO TOP
	LOCATE FOR NOT AT(UPPER(_grx_search),UPPER(grx.comment))=0
	_grx_found=.F.
	DO WHILE .T.
		IF FOUND()
			_grx_found=.T.
			_grx_sf_width=grx.width
			REPL grx.hpos WITH _grx_sf_pos
			CONT
		ELSE
			IF NOT _grx_found
				=_grx_warning("The field "+ALLT(_grx_search)+" was not defined... - [ENTER]")
			ENDIF
			EXIT
		ENDIF
	ENDDO
	_grx_sf_pos=_grx_sf_pos+_grx_sf_add+_grx_sf_width
ENDDO

* 1. Driver
IF "_GRXDRV1"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV1"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV1",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

* mark unused fields with *:DELOBJ
IF NOT EMPTY(_grx_2fld_sort)
	GO TOP
	SCAN FOR NOT AT(_grxf_sort_obj,grx.comment)=0
		_grx_search=ALLT(SUBS(grx.comment,AT(_grxf_sort_obj,grx.comment)+LEN(_grxf_sort_obj)))
		IF NOT AT(CHR(13),_grx_search)=0
			_grx_search=LEFT(_grx_search,AT(CHR(13),_grx_search)-1)
		ENDIF
		IF NOT AT(CHR(10),_grx_search)=0
			_grx_search=LEFT(_grx_search,AT(CHR(10),_grx_search)-1)
		ENDIF
		IF AT(UPPER(_grx_search),UPPER(_grx_2fld_sort))=0
			REPL grx.comment WITH grx.comment+cr_lf+_grxf_delobj
		ENDIF
	ENDSCAN
ENDIF

* 2. Driver
IF "_GRXDRV2"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV2"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV2",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

* Reposition fields...
GO TOP
SCAN
	IF NOT AT(_grxf_pos_over,grx.comment)=0
		_grx_search=SUBS(grx.comment,AT(_grxf_pos_over,grx.comment)+LEN(_grxf_pos_over))
		IF NOT AT(CHR(13),_grx_search)=0
			_grx_search=LEFT(_grx_search,AT(CHR(13),_grx_search)-1)
		ENDIF
		mrec=RECN()
		GO TOP
		_grx_search="*:DEFOBJ "+ALLT(UPPER(_grx_search))
		_grx_allign=1		&& Left allignment
		IF NOT AT("LEFT",UPPER(_grx_search))=0
			_grx_allign=1
			_grx_search=STRT(_grx_search,"LEFT","")
			_grx_search=STRT(_grx_search,"left","")
			_grx_search=STRT(_grx_search,"Left","")
			_grx_search=ALLT(_grx_search)
		ENDIF
		IF NOT AT("CENTER",UPPER(_grx_search))=0
			_grx_allign=2
			_grx_search=STRT(_grx_search,"CENTER","")
			_grx_search=STRT(_grx_search,"center","")
			_grx_search=STRT(_grx_search,"Center","")
			_grx_search=ALLT(_grx_search)
		ENDIF
		IF NOT AT("RIGHT",UPPER(_grx_search))=0
			_grx_allign=3
			_grx_search=STRT(_grx_search,"RIGHT","")
			_grx_search=STRT(_grx_search,"right","")
			_grx_search=STRT(_grx_search,"Right","")
			_grx_search=ALLT(_grx_search)
		ENDIF
		LOCATE FOR NOT AT(UPPER(_grx_search),UPPER(grx.comment))=0 AND AT(UPPER(_grxf_delete),UPPER(grx.comment))=0 AND AT(UPPER(_grxf_delobj),UPPER(grx.comment))=0
		IF FOUND()
			mpos=grx.hpos
			mpos2=grx.width
			GO mrec
			REPL grx.hpos WITH mpos
			REPL grx.width WITH mpos2
			* Change Allignment...
			DO CASE
				CASE _grx_allign=1			&& Left allignment
					* Search for other allignment...
					REPL PICTURE WITH STRT(PICTURE,"I","")			&& Delete centered allignment...
					REPL PICTURE WITH STRT(PICTURE,"J","")			&& Delete right allignment...
				CASE _grx_allign=2			&& Centered allignment
					* Search for other allignment...
					REPL PICTURE WITH STRT(PICTURE,"J","")			&& Delete right allignment...
					IF AT("I",PICTURE)=0
						REPL PICTURE WITH STRT(PICTURE,"@","@I")		&& Add centered allignment if a picture-clausel exists...
						IF EMPTY(PICTURE)
							REPL PICTURE WITH '"@I"'					&& If empty picure field, add centered allignment...
						ENDIF
					ENDIF
				CASE _grx_allign=3			&& Right allignment
					* Search for other allignment...
					REPL PICTURE WITH STRT(PICTURE,"I","")			&& Delete centered allignment...
					IF AT("J",PICTURE)=0
						REPL PICTURE WITH STRT(PICTURE,"@","@J")		&& Add right allignment if a picture-clausel exists...
						IF EMPTY(PICTURE)
							REPL PICTURE WITH '"@J"'					&& If empty picure field, add right allignment...
						ENDIF
					ENDIF
			ENDCASE
		ELSE
			GO mrec
			REPL grx.comment WITH grx.comment+cr_lf+_grxf_delobj
		ENDIF
	ENDIF
ENDSCAN

* 3. Driver
IF "_GRXDRV3"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV3"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV3",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

* Define Classes...
GO TOP
SCAN					&& Pre-Run 1
	* Verndere alle " in '...
	REPL grx.comment WITH STRT(grx.comment,'"',"'")

	* Create When-Classes...
	IF NOT _grx_at(_grxf_crwcl,grx.comment)=0
		* new class sentence...
		IF !(ALEN(_grxcl_when)=_grx_wc_cols AND EMPTY(_grxcl_when(1,1)))
			DIME _grxcl_when((ALEN(_grxcl_when)/_grx_wc_cols)+1,_grx_wc_cols)
		ENDIF
		* store class-name
		_grx_dummy=SUBSTR(grx.comment,_grx_at(_grxf_crwcl,grx.comment)+LEN(_grxf_crwcl))
		_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,1)=STRT(ALLT(_grx_dummy),CHR(13)," ")
		IF NOT AT(" ",_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,1))=0
			_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,1)=ALLT(LEFT(_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,1),AT(" ",_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,1))))
		ENDIF
		* store class-when
		_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,2)=grx.supexpr
		_grxcl_when(ALEN(_grxcl_when)/_grx_wc_cols,3)=grx.norepeat
	ENDIF

	* Create Expression-Classes...
	IF NOT _grx_at(_grxf_crecl,grx.comment)=0
		* new class sentence...
		IF !(ALEN(_grxcl_expr)=_grx_ec_cols AND EMPTY(_grxcl_expr(1,1)))
			DIME _grxcl_expr((ALEN(_grxcl_expr)/_grx_ec_cols)+1,_grx_ec_cols)
		ENDIF
		* store class-name
		_grx_dummy=SUBSTR(grx.comment,_grx_at(_grxf_crecl,grx.comment)+LEN(_grxf_crecl))
		_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,1)=STRT(ALLT(_grx_dummy),CHR(13)," ")
		IF NOT AT(" ",_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,1))=0
			_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,1)=ALLT(LEFT(_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,1),AT(" ",_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,1))))
		ENDIF
		* store class-expr.
		_grxcl_expr(ALEN(_grxcl_expr)/_grx_ec_cols,2)=grx.expr
	ENDIF

	* Create Format-Classes...
	IF NOT _grx_at(_grxf_crfcl,grx.comment)=0
		* new class sentence...
		IF !(ALEN(_grxcl_fmt)=_grx_fc_cols AND EMPTY(_grxcl_fmt(1,1)))
			DIME _grxcl_fmt((ALEN(_grxcl_fmt)/_grx_fc_cols)+1,_grx_fc_cols)
		ENDIF
		* store class-name
		_grx_dummy=SUBSTR(grx.comment,_grx_at(_grxf_crfcl,grx.comment)+LEN(_grxf_crfcl))
		_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,1)=STRT(ALLT(_grx_dummy),CHR(13)," ")
		IF NOT AT(" ",_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,1))=0
			_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,1)=ALLT(LEFT(_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,1),AT(" ",_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,1))))
		ENDIF
		* store class-format.
		_grxcl_fmt(ALEN(_grxcl_fmt)/_grx_fc_cols,2)=grx.picture
	ENDIF

ENDSCAN

* 4. Driver
IF "_GRXDRV4"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV4"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV4",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

* Use Classes
GO TOP
SCAN					&& Pre-Run 2
	* Use When-Classes
	IF NOT _grx_at(_grxf_usewcl,grx.comment)=0
		* search class-name
		_grx_dummy=ALLT(SUBSTR(grx.comment,_grx_at(_grxf_usewcl,grx.comment)+LEN(_grxf_usewcl)))
		_grx_dummy=STRT(ALLT(_grx_dummy),CHR(13)," ")
		_grx_dummy=ALLT(LEFT(_grx_dummy,AT(" ",_grx_dummy)))
		IF NOT ASCAN(_grxcl_when,_grx_dummy)=0
			_grx_dummy=(ASCAN(_grxcl_when,_grx_dummy)+_grx_wc_cols-1)/_grx_wc_cols
			* store class-when
			REPL grx.supexpr WITH _grxcl_when(_grx_dummy,2)
			REPL grx.norepeat WITH _grxcl_when(_grx_dummy,3)
		ELSE
			?? CHR(7)
			=_grx_warning("When-Class '"+ALLT(_grx_dummy)+"' not defined... - [ENTER]")
		ENDIF
	ENDIF

	* Use Expression-Class
	IF NOT _grx_at(_grxf_useecl,grx.comment)=0
		* search class-name
		_grx_dummy=ALLT(SUBSTR(grx.comment,_grx_at(_grxf_useecl,grx.comment)+LEN(_grxf_useecl)))
		_grx_dummy=STRT(ALLT(_grx_dummy),CHR(13)," ")
		_grx_dummy=ALLT(LEFT(_grx_dummy,AT(" ",_grx_dummy)))
		IF NOT ASCAN(_grxcl_expr,_grx_dummy)=0
			_grx_dummy=(ASCAN(_grxcl_expr,_grx_dummy)+_grx_ec_cols-1)/_grx_ec_cols
			* store class-when
			REPL grx.expr WITH _grxcl_expr(_grx_dummy,2)
		ELSE
			?? CHR(7)
			=_grx_warning("Expression-Class '"+ALLT(_grx_dummy)+"' not defined... - [ENTER]")
		ENDIF
	ENDIF

	* Use Format-Class
	IF NOT _grx_at(_grxf_usefcl,grx.comment)=0
		* search class-name
		_grx_dummy=ALLT(SUBSTR(grx.comment,_grx_at(_grxf_usefcl,grx.comment)+LEN(_grxf_usefcl)))
		_grx_dummy=STRT(ALLT(_grx_dummy),CHR(13)," ")
		_grx_dummy=ALLT(LEFT(_grx_dummy,AT(" ",_grx_dummy)))
		IF NOT ASCAN(_grxcl_fmt,_grx_dummy)=0
			_grx_dummy=(ASCAN(_grxcl_fmt,_grx_dummy)+_grx_fc_cols-1)/_grx_fc_cols
			* store class-when
			REPL grx.picture WITH _grxcl_fmt(_grx_dummy,2)
		ELSE
			?? CHR(7)
			=_grx_warning("Format-Class '"+ALLT(_grx_dummy)+"' not defined... - [ENTER]")
		ENDIF
	ENDIF

ENDSCAN

* 5. Driver
IF "_GRXDRV5"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV5"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV5",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

* Insert or delete reccords...
GO TOP
SCAN
	* Delete Objects (*:DELETE)
	IF NOT _grx_at(_grxf_delete,grx.comment)=0
		DELE
	ENDIF

	* Color-Anweisungen definieren (*:IF_COLOR)
	IF NOT _grx_at(_grxf_if_color,grx.comment)=0
		_grx_x=1
		DO WHILE .T.
			IF NOT _grx_at(_grxf_if_color,grx.comment,_grx_x)=0
				_grx_x=_grx_x+1
			ELSE
				EXIT
			ENDIF
		ENDDO
		_grx_oldrec=RECN()
		FOR i=3 TO _grx_x		&& Stze je nach Anzahl der Bedingungen kopieren...
			=duprec()
		ENDFOR
		GO _grx_oldrec
		FOR i=2 TO _grx_x
			_grx_bed=ALLT(SUBSTR(grx.comment,_grx_at(_grxf_if_color,grx.comment,i-1)))
			_grx_bed=ALLT(STRT(_grx_bed,_grxf_if_color,""))
			IF NOT AT(CHR(13),_grx_bed)=0
				_grx_bed=LEFT(_grx_bed,AT(CHR(13),_grx_bed))
			ENDIF
			_grx_bed=STRT(_grx_bed,CHR(13),"")
			IF NOT AT("FONT",UPPER(_grx_bed))=0
				_grx_font=SUBS(_grx_bed,AT("FONT",UPPER(_grx_bed))+5)
				REPL grx.fontface WITH ALLT(STRT(STRT(STRT(LEFT(_grx_font,AT(" ",_grx_font)),"'",""),"[",""),"]",""))
				_grx_fontsize=SUBS(ALLT(_grx_font),AT(",",_grx_font))
				_grx_fontsize=ALLT(STRT(_grx_fontsize,",",""))
				IF NOT AT(" ",_grx_fontsize)=0
					REPL grx.fontsize WITH VAL(LEFT(_grx_fontsize,AT(" ",_grx_fontsize)))
				ELSE
					REPL grx.fontsize WITH VAL(_grx_fontsize)
				ENDIF
				IF NOT AT("STYLE",UPPER(_grx_bed))=0
					_grx_style=ALLT(STRT(SUBS(_grx_bed,AT("STYLE",UPPER(_grx_bed))+6),"'",""))
					REPL grx.fontstyle WITH 0
					IF NOT AT("B",UPPER(_grx_style))=0			&& Fett...
						REPL grx.fontstyle WITH grx.fontstyle+1
					ENDIF
					IF NOT AT("I",UPPER(_grx_style))=0			&& Kursiv (Italic)...
						REPL grx.fontstyle WITH grx.fontstyle+2
					ENDIF
					IF NOT AT("U",UPPER(_grx_style))=0			&& Unterstrichen...
						REPL grx.fontstyle WITH grx.fontstyle+4
					ENDIF
				ENDIF
			ENDIF
			IF NOT AT("COLOR",UPPER(_grx_bed))=0
				_grx_col=SUBS(_grx_bed,AT("COLOR",UPPER(_grx_bed))+6)
				_grx_col=STRT(UPPER(_grx_col),"RGB(","")
				_grx_col=STRT(UPPER(_grx_col),")","")
				_grx_pair=ALLT(_grx_col)
				_grx_col1=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
				_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
				_grx_col2=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
				_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
				_grx_col3=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
				_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
				_grx_col4=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
				_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
				_grx_col5=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
				_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
				_grx_col6=VAL(STRT(_grx_pair,",",""))
				REPL penred WITH _grx_col1
				REPL pengreen WITH _grx_col2
				REPL penblue WITH _grx_col3
				REPL fillred WITH _grx_col4
				REPL fillgreen WITH _grx_col5
				REPL fillblue WITH _grx_col6
				_grx_bed=LEFT(_grx_bed,AT("COLOR",UPPER(_grx_bed))-1)
				* Sollte sich im Ausdruck noch eine Font-Anweisung befinden, so wird diese ausgefiltert...
				IF NOT AT("FONT",UPPER(_grx_bed))=0
					_grx_bed=LEFT(_grx_bed,AT("FONT",UPPER(_grx_bed))-1)
				ENDIF
			ENDIF
			IF EMPTY(grx.supexpr)
				REPL grx.supexpr WITH _grx_bed
			ELSE
				REPL grx.supexpr WITH "("+ALLT(grx.supexpr)+") and ("+ALLT(_grx_bed)+")"
			ENDIF
			*:IF_COLOR temporr in *#IF_COLOR umwandeln, damit diese Bedingung nicht doppelt ausgefhrt werden kann...
			REPL grx.comment WITH STRT(grx.comment,_grxf_if_color,"*:#IF_COLOR")
			SKIP
		ENDFOR
	ENDIF

ENDSCAN

* 6. Driver
IF "_GRXDRV6"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV6"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV6",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

GO TOP
SCAN			&& Scan the whole Database... (Standard-Run)

	***********************************************************************
	* Change Color-Values... (using the *:RGB_COLOR - Statement...
	* With this statement, you can use all the existing
	* RGB-Values (like 86,34,124,200,231,219)...
	*
	* Comment-Snippet-Syntax:
	* *:RGB_COLOR penred,pengreen,penblue,fillred,fillgreen,fillblue
	*             Color Range: 1-255, step 1
	***********************************************************************

	IF NOT _grx_at(_grxf_colors,grx.comment)=0
		_grx_pair=SUBSTR(comment,_grx_at(_grxf_colors,grx.comment)+11,100)
		_grx_pair=ALLT(_grx_pair)
		_grx_pair=STRT(_grx_pair," ","")
		_grx_col1=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
		_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
		_grx_col2=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
		_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
		_grx_col3=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
		_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
		_grx_col4=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
		_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
		_grx_col5=VAL(STRT(LEFT(_grx_pair,AT(",",_grx_pair)),",",""))
		_grx_pair=RIGHT(_grx_pair,LEN(_grx_pair)-AT(",",_grx_pair))
		_grx_col6=VAL(STRT(LEFT(_grx_pair,AT(" ",_grx_pair)),",",""))
		REPL penred WITH _grx_col1
		REPL pengreen WITH _grx_col2
		REPL penblue WITH _grx_col3
		REPL fillred WITH _grx_col4
		REPL fillgreen WITH _grx_col5
		REPL fillblue WITH _grx_col6
	ENDIF

	***********************************************************************
	* Use underlined fontstyles
	* You can use the *:UNDERLINED-STATEMENT with every kind of
	* Object you want...
	*
	* Comment-Snippet-Syntax:
	* *:UNDERLINE
	***********************************************************************

	IF NOT _grx_at(_grxf_underline,grx.comment)=0
		REPL grx.fontstyle WITH grx.fontstyle+4
		DO WHILE grx.fontstyle>7
			REPL grx.fontstyle WITH grx.fontstyle-4
		ENDDO
	ENDIF

	IF _grx_must_comp
		* Generate Functions...
		IF NOT _grx_at(_grxf_begfnctn,grx.comment)=0
			_grx_fudummy=SUBS(grx.comment,_grx_at(_grxf_begfnctn,grx.comment)+LEN(_grxf_begfnctn))
			IF NOT _grx_at(_grxf_endfnctn,_grx_fudummy)=0
				_grx_fudummy=LEFT(_grx_fudummy,_grx_at(_grxf_endfnctn,_grx_fudummy)-1)
			ENDIF
			_grx_du_rec=RECN()
			GO TOP
			REPL grx.picture WITH grx.picture+cr_lf+"proc "+ALLT(_grx_fudummy)
			GO _grx_du_rec
		ENDIF
	ENDIF

	* Detailbereich einfgen...
	IF NOT _grx_at(_grxf_detail,grx.comment)=0
		_grx_dummy=ALLT(SUBSTR(grx.comment,_grx_at(_grxf_detail,grx.comment)))
		IF NOT AT(CHR(13),_grx_dummy)=0
			_grx_dummy=ALLT(LEFT(_grx_dummy,AT(CHR(13),_grx_dummy)))
		ENDIF
		_grx_for=""
		IF NOT AT("FOR",_grx_dummy)=0
			_grx_for=RIGHT(_grx_dummy,LEN(_grx_dummy)-AT("FOR",_grx_dummy)+1)
			_grx_for=ALLT(STRT(_grx_for,"FOR ",""))
		ENDIF
		_grx_dbf=ALLT(STRT(_grx_dummy,_grxf_detail,""))
		IF NOT AT(" ",_grx_dbf)=0
			_grx_dbf=ALLT(LEFT(_grx_dbf,AT(" ",_grx_dbf)))
		ENDIF
		_grx_vartype="C"
		IF NOT EMPTY(grx.fillchar)
			_grx_vartype=grx.fillchar
		ENDIF
		_grx_pict=STRT(grx.picture,'"',"")
		REPL grx.expr WITH "_grx_det('"+ALLT(STRT(grx.expr,CHR(13),""))+"','"+ALLT(STRT(_grx_dbf,CHR(13),""))+"','"+_grx_vartype+"','"+ALLT(STRT(_grx_for,CHR(13),""))+"','"+_grx_pict+"')"
		REPL grx.stretch WITH .T.
		REPL grx.top WITH .F.
		REPL grx.picture WITH ""
		REPL grx.fillchar WITH "C"
	ENDIF

ENDSCAN

LOCATE
IF _grx_must_comp AND NOT EMPTY(grx.picture)
	* Programmablauf durch das neue Procedure-File schleifen...
	REPL grx.picture WITH "DO GRX_CONT"+cr_lf+"RETURN"+cr_lf+cr_lf+grx.picture
ENDIF

* 7. Driver
IF "_GRXDRV7"$grx_defi.config
	FOR _grx_i=1 TO MEMLINES(grx_defi.config)
		IF "_GRXDRV7"$MLINE(grx_defi.config,_grx_i)
			_grx_bef=STRT(STRT(STRT(MLINE(grx_defi.config,_grx_i),"_GRXDRV7",""),"=",""),'"',"")
			SCAN
				DO &_grx_bef
			ENDSCAN
		ENDIF
	ENDFOR
ENDIF

GO TOP
SCAN					&& Post-Run 1
	* Insert external Whens...
	IF grx.supexpr="{{&"
		REPL grx.supexpr WITH STRT(grx.supexpr,"{","")
		REPL grx.supexpr WITH STRT(grx.supexpr,"}","")
		_grx_auf_vari=ALLT(grx.supexpr)
		REPL grx.supexpr WITH &_grx_auf_vari
	ENDIF

	* Insert external Pictures...
	IF grx.picture='"{{&'
		REPL grx.picture WITH STRT(grx.picture,"{","")
		REPL grx.picture WITH STRT(grx.picture,"}","")
		REPL grx.picture WITH STRT(grx.picture,'"',"")
		_grx_auf_vari=ALLT(grx.picture)
		REPL grx.picture WITH &_grx_auf_vari
		REPL grx.picture WITH '"'+ALLT(grx.picture)+'"'
	ENDIF

	* Delete Objects (*:DELOBJ)
	IF NOT _grx_at(_grxf_delobj,grx.comment)=0
		DELE
	ENDIF

ENDSCAN


* Compile Functions
GO TOP
IF _grx_must_comp
	IF NOT EMPTY(grx.picture)
		IF FILE("GRX_COMP.PRG")
			ERASE grx_comp.prg
		ENDIF
		IF FILE("GRX_COMP.FXP")
			ERASE grx_comp.fxp
		ENDIF
		COPY MEMO grx.picture TO grx_comp.prg
		COMPILE grx_comp.prg
		APPE MEMO grx.supexpr FROM grx_comp.fxp

		*Write functions to real report...
		fusele=SELE()
		SELE 0
		_grx_proc_rep=ALLT(UPPER(_grx_rep_name))+".FRX"
		USE &_grx_proc_rep
		GO TOP
		REPL PICTURE WITH ""
		REPL supexpr WITH ""
		APPE MEMO PICTURE FROM grx_comp.prg
		APPE MEMO supexpr FROM grx_comp.fxp
		USE
		SELE (fusele)
	ENDIF
ENDIF

* compress dummy-Database
PACK

* if functions are available...
GO TOP
_grx_lib_todo=.F.					&& Is there a lib-file?
IF NOT EMPTY(grx.picture)
	COPY MEMO grx.supexpr TO grx_libr.fxp
	COPY MEMO grx.picture TO grx_libr.prg
	_grx_lib_todo=.T.				&& yes, it is...
ENDIF

WAIT CLEAR

* compress dummy-Database and select old (real) database...
USE
SELE (_grx_sele)

IF _grx_lib_todo
	_grx_todo="do grx_libr.prg"
	&_grx_todo					&& Wenn eine Library vorhanden ist, zuerst durch diese schleifen...
ELSE
	DO grx_cont						&& Wenn keine Library vorhanden ist, sofort ausfhren...
ENDIF
* if Function-File Exists... delete it!
IF FILE("grx_libr.fxp")
	ERASE grx_libr.fxp
ENDIF
IF FILE("grx_libr.prg")
	ERASE grx_libr.prg
ENDIF
RETURN


PROC grx_cont
* This routine executes the report...
* All done --> execute Report
IF _grx_run
	REPO FORM genrepox &_grx_rep_expr
ENDIF
RETURN .T.



PROC _grx_at
PARA find_str, find_vari, find_num
IF PARA()<3
	find_num=1
ENDIF
RETURN AT(UPPER(find_str),UPPER(find_vari),find_num)


PROC _grx_warning
PARA _grx_warn_text
?? CHR(7)
WAIT WIND _grx_warn_text
RETURN .T.



* Detail-Extender...
PROC _grx_det
PARA FIELD, DBF, var_type, bedingung, _det_pict
IF PARA()<5
	_det_pict=""
ENDIF
_det_sele=SELE()
_grx_retval=""
SELE (DBF)
_grx_oldfi=SET("FILTER")
SET FILTER TO
SET FILTER TO &bedingung
GO TOP
DO WHILE NOT EOF()
	IF NOT EMPTY(_grx_retval)
		_grx_retval=_grx_retval+cr_lf
	ENDIF
	DO CASE
		CASE var_type="C" OR var_type="M"
			_grx_retval=_grx_retval+ALLT(&field)
			IF NOT EMPTY(_det_pict)
				_grx_retval=TRAN(_grx_retval,_det_pict)
			ENDIF
		CASE var_type="N"
			IF NOT EMPTY(_det_pict)
				_grx_retval=_grx_retval+TRAN(&field,_det_pict)
			ELSE
				_grx_retval=_grx_retval+ALLT(STR(&field))
			ENDIF
		CASE var_type="D"
			IF NOT EMPTY(_det_pict)
				_grx_retval=TRAN(_grx_retval,_det_pict)
			ELSE
				_grx_retval=_grx_retval+TRAN(&field,_det_pict)
			ENDIF
		CASE var_type="L"
			_grx_retval=_grx_retval+ALLT(IIF(&field,".T.",".F."))
	ENDCASE
	SKIP
ENDDO
SET FILTER TO
SET FILTER TO &_grx_oldfi
SELE (_det_sele)
RETURN _grx_retval


PROC is_exe
RETURN "EXE"$UPPER(VERSION(1))


PROC fox_ver
RETURN VAL(ALLT(RIGHT(ALLT(LEFT(VERS(),AT(" ",VERS(),2))),AT(" ",VERS(),2)-AT(" ",VERS()))))


PROC calc_for
PARA operation, vari, su_for
grx_rec=RECN()
IF PARA()<3
	su_for=""
ENDIF
operation=ALLT(UPPER(operation))
retval=0
DO CASE
	CASE operation="SUM"
		IF EMPTY(su_for)
			SUM &vari ALL TO retval
		ELSE
			SUM &vari ALL TO retval FOR &su_for
		ENDIF
	OTHER
		retval=0
ENDCASE
IF NOT grx_rec>RECC()
	GO grx_rec
ENDIF
RETURN retval


FUNCTION duprec
PARA dummy
RELEASE a_fscatter
SCATTER TO a_fscatter MEMO
INSERT BLANK
GATHER FROM a_fscatter MEMO
REPL timestamp WITH _grx_stamp
_grx_stamp=_grx_stamp+1
RETURN .T.
